package blatt7;

import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class GuestbookServlet extends HttpServlet{
	Guestbook db;
	 
	public GuestbookServlet() throws Exception{
		super();
		db = new Guestbook();
		//db.addEntry("me", "A great Site. <br /> The best invention sice sliced bread!");
	}
	
	private static final long serialVersionUID = 1L;

	public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		doGet(request, response);
	}
	
	public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		response.setContentType("text/html");
		
		PrintWriter writer = response.getWriter();
		processForm(request);
		writer.println("<?xml version=\"1.0\" encoding=\"UTF-8\" ?>");
		writer.println("<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">");
		writer.println("<html>");
		writer.println("<head><title>Guestbook</title></head>");
		writer.println("<body>");
		writer.println("<h1>Guestbook</h1>");
		printForm(writer);
		printGuestbook(writer);
		writer.println("</body>");
		writer.println("</html>");
	}

	private void printGuestbook(PrintWriter writer) {
		if(!db.isEmpty()){
			for(GuestbookEntry e : db.getEntries()){
				writer.println("<p><div  style=\"font-weight:bold\">" + e.getAuthor() + "</div> wrote on "
				+ e.getDateString() + ":</p>");
				writer.println("<p>" + e.getMessage() + "</p>");
			}	
		}
	}
	
	private void processForm(HttpServletRequest request){
		String name = request.getParameter("name");
		String msg = request.getParameter("message");
		if(name != null && msg != null) db.addEntry(name, msg);
	}
	
	private void printForm(PrintWriter writer){
		writer.println("<form method=\"GET\" action=\"/blatt7/guestbook\">");
		writer.println("<p>Name: <input type=\"text\" name=\"name\" /> </p>");
		writer.println("<p>Message: <input type=\"text\" name=\"message\" /></p>");
		writer.println("<p><input type=\"submit\" value=\"Submit\" /></p>");
		writer.println("</form>");
	}
}
